import _regeneratorRuntime from "@babel/runtime-corejs3/regenerator";
import "regenerator-runtime/runtime";
import _asyncToGenerator from "@babel/runtime-corejs3/helpers/esm/asyncToGenerator";
import _slicedToArray from "@babel/runtime-corejs3/helpers/esm/slicedToArray";
import React, { useState, useEffect } from "react";
import PropTypes from "prop-types";
import Subspace from "@embarklabs/subspace";
import SubspaceContext from "./subspaceContext";

function SubspaceProvider(_ref) {
  var children = _ref.children,
      web3 = _ref.web3,
      options = _ref.options;

  var _useState = useState(),
      _useState2 = _slicedToArray(_useState, 2),
      subspace = _useState2[0],
      setSubspace = _useState2[1];

  useEffect(function () {
    var s;

    _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              s = new Subspace(web3, options);
              _context.next = 3;
              return s.init();

            case 3:
              setSubspace(s);

            case 4:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();

    return function () {
      if (s) s.close();
    };
  }, [web3]);
  if (!subspace) return null;
  return React.createElement(SubspaceContext.Provider, {
    value: subspace
  }, children);
}

SubspaceProvider.defaultProps = {
  children: null,
  options: {}
};
SubspaceProvider.propTypes = {
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node]),
  web3: PropTypes.object.isRequired
};
export default SubspaceProvider;
//# sourceMappingURL=SubspaceProvider.js.map