"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime-corejs3/helpers/interopRequireWildcard");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _subspace = _interopRequireDefault(require("@embarklabs/subspace"));

var _subspaceContext = _interopRequireDefault(require("./subspaceContext"));

function SubspaceProvider({
  children,
  web3,
  options
}) {
  const [subspace, setSubspace] = (0, _react.useState)();
  (0, _react.useEffect)(() => {
    let s;

    (async () => {
      s = new _subspace.default(web3, options);
      await s.init();
      setSubspace(s);
    })();

    return () => {
      if (s) s.close();
    };
  }, [web3]);
  if (!subspace) return null;
  return _react.default.createElement(_subspaceContext.default.Provider, {
    value: subspace
  }, children);
}

SubspaceProvider.defaultProps = {
  children: null,
  options: {}
};
SubspaceProvider.propTypes = {
  children: _propTypes.default.oneOfType([_propTypes.default.arrayOf(_propTypes.default.node), _propTypes.default.node]),
  web3: _propTypes.default.object.isRequired
};
var _default = SubspaceProvider;
exports.default = _default;
//# sourceMappingURL=SubspaceProvider.js.map